﻿#region System Namespace
using System;

    #endregion System Namespace

#region Foreign Namespace
#endregion Foreign Namespace

#region Styx Namespace

using System.Linq;
using Styx;
using Styx.Pathing;
using Styx.Plugins;
using Styx.Common;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;
#endregion Styx Namespace

namespace KillThisMob
{
    public class KillThisMob : HBPlugin
    {
        public override string Name { get { return "KillThisMob"; } }
        public override string Author { get { return "Giwin"; } }
        public override Version Version { get { return new Version(1, 0); } }
        public override bool WantButton { get { return true; } }

        public override void OnButtonPress()
        {
            new Form1().ShowDialog();
        }

        public override void Initialize()
        {
            Logging.Write("KillThisMob - Loaded Version " + Version);
        }

        public override void Pulse()
        {
            if (StyxWoW.IsInGame)
            {
                //to call a setting its 
                if (StyxWoW.Me.IsAlive)
                {
                    foreach (WoWUnit unit in ObjectManager.GetObjectsOfType<WoWUnit>(false,false).Where(unit => unit != null &&
                        unit.Name == MIRsettings.Instance.MobName &&
                        unit.IsValid &&
                        unit.IsAlive))
                    {
                        if (StyxWoW.Me.CurrentTarget == null || StyxWoW.Me.CurrentTarget.Name != unit.Name)
                        {
                            unit.Target();
                        }
                        while (StyxWoW.Me.CurrentTarget != null &&
                               StyxWoW.Me.CurrentTarget.Name == MIRsettings.Instance.MobName &&
                               !StyxWoW.Me.Combat &&
                               StyxWoW.Me.CurrentTarget.Distance > 5)
                        {
                            if (StyxWoW.Me.CurrentTarget.Distance < 5 && StyxWoW.Me.Mounted)
                            {
                                Lua.DoString("/dismount");
                            }
                            else
                            {
                                Flightor.MoveTo(StyxWoW.Me.CurrentTarget.Location);
                            }
                        }
                    }
                }
            }
        }
    }
}